using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;
using System.Data;

namespace AdomdDataReaderSample
{
	class Program
	{
		static void Main(string[] args)
		{
			//Open the connection to the server
			AdomdConnection con = new AdomdConnection();
			con.ConnectionString = "Datasource = localhost;Initial Catalog=Foodmart 2005;";
			con.Open();

			//Create and execute an MDX query
			AdomdCommand command = con.CreateCommand();
			command.CommandText = "SELECT {[Measures].[Store Cost], [Measures].[Store Sales]} ON COLUMNS FROM [Warehouse and Sales]";
			AdomdDataReader reader = command.ExecuteReader();

			// Read the metadata about the columns
			DataTable schemaTable = reader.GetSchemaTable();
			Console.WriteLine("Schema Information about resultset");
			foreach (DataRow schRow in schemaTable.Rows)
			{
				foreach (DataColumn schColumn in schemaTable.Columns)
				{
					Console.Write(schColumn.ColumnName + ":");
					Console.WriteLine(schRow[schColumn].ToString());
				}
			}

			//Another way to access that metadata is to call the method AdomdDataReader.GetName(), but if the result contains no rows, this approach wont work.
			Console.WriteLine("Name of the columns");
			for (int iCol = 0; iCol < reader.FieldCount; iCol++)
			{
				Console.WriteLine(reader.GetName(iCol));
			}

			//Iterate the values
			Console.WriteLine("Values in the resultset");
			while (reader.Read())
			{
				for (int iCol = 0; iCol < reader.FieldCount; iCol++)
				{
					Console.Write("Value: " + reader.GetValue(iCol));
					Console.WriteLine("Type: " + reader.GetDataTypeName(iCol));
				}
			}
			// Close the DataReader
			reader.Close();

			//Close the connection
			con.Close();

		}
	}
}
