using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.AnalysisServices.AdomdClient;

namespace AdomdDisplayCellSet
{
	public partial class Form1 : Form
	{
		private const int colSize = 100;
		private const int rowSize = 20;

		public Form1()
		{
			InitializeComponent();
			this.AdomdGrid.Visible = false;
		}


		#region InitializeGrid
		private void InitializeGrid(int colCount, int rowCount, int colCaption, int rowCaption)
		{
			this.AdomdGrid.Visible = true;
			this.AdomdGrid.Size = this.Size;
			// Create view as layout
			this.AdomdGrid.CreateView(INVIEWLib.INViewType.inLayout);

			// Get current layout
			this.gridLayout = (INVIEWLib.Layout)this.AdomdGrid.View;

			// Set layout style for every cell
			gridLayout.InitProperty(INVIEWLib.INPropertyID.inStyle, INVIEWLib.INLayoutPropertyLink.inPerView, INVIEWLib.INCellStyle.inTextLeft);
			gridLayout.InitProperty(INVIEWLib.INPropertyID.inDeltaWidth, INVIEWLib.INLayoutPropertyLink.inPerLayout, 0);
			gridLayout.InitProperty(INVIEWLib.INPropertyID.inDeltaHeight, INVIEWLib.INLayoutPropertyLink.inPerLayout, 0);

			// Set layout 
			this.gridLayout.Init(2, 2);

			// Set layout size
			this.gridLayout.SetColWidth(1, (colCaption > 5) ? 5 * colSize : colCaption * colSize);
			this.gridLayout.SetRowHeight(1,(rowCaption > 5 ) ? 5*rowSize : rowCaption * rowSize);

			// Create corner grid
			this.cornerGrid = (INVIEWLib.Grid)gridLayout.CreateView(1, 1, 1, 1, INVIEWLib.INViewType.inGrid);
			this.cornerGrid.InitProperty(INVIEWLib.INPropertyID.inBackColor, INVIEWLib.INGridPropertyLink.inPerCell, ARGB(Color.Gray));//rgb
			this.cornerGrid.InitProperty(INVIEWLib.INPropertyID.inStyle, INVIEWLib.INGridPropertyLink.inPerCell, INVIEWLib.INCellStyle.inTextLeft | INVIEWLib.INCellStyle.inTextSingleline | INVIEWLib.INCellStyle.inView3dOn);
			this.cornerGrid.InitProperty(INVIEWLib.INPropertyID.inWidth, INVIEWLib.INGridPropertyLink.inPerGrid,  colSize);
			this.cornerGrid.EventOff(INVIEWLib.INCallbackEvent.inOnAllEvents);
			this.cornerGrid.Init(rowCaption, colCaption);

			// Create row grid
			this.rowGrid = (INVIEWLib.Grid)gridLayout.CreateView(2, 2, 1, 1, INVIEWLib.INViewType.inGrid);

			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inBackColor, INVIEWLib.INGridPropertyLink.inPerCell, ARGB(Color.Gray));//rgb
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inStyle, INVIEWLib.INGridPropertyLink.inPerCell, INVIEWLib.INCellStyle.inTextLeft | INVIEWLib.INCellStyle.inTextSingleline | INVIEWLib.INCellStyle.inView3dOn);
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inWidth, INVIEWLib.INGridPropertyLink.inPerGrid, colSize);
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inState, INVIEWLib.INGridPropertyLink.inPerCell, INVIEWLib.INCellState.inTextDraw | INVIEWLib.INCellState.inTextRect | INVIEWLib.INCellState.inRegularView);
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaRows, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaCols, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaWidth, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.rowGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaHeight, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.rowGrid.Init(rowCount, colCaption);
			// Events on data grid
			this.rowGrid.EventOff(INVIEWLib.INCallbackEvent.inOnAllEvents);
			// Style for data grid
			this.rowGrid.StyleOn(INVIEWLib.INViewStyle.inScrollHorzEnable);

			// Create column grid
			this.colGrid = (INVIEWLib.Grid)gridLayout.CreateView(1, 1, 2, 2, INVIEWLib.INViewType.inGrid);

			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inBackColor, INVIEWLib.INGridPropertyLink.inPerCell, ARGB(Color.Gray));//rgb
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inStyle, INVIEWLib.INGridPropertyLink.inPerCell, INVIEWLib.INCellStyle.inTextLeft | INVIEWLib.INCellStyle.inTextSingleline | INVIEWLib.INCellStyle.inView3dOn);
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inWidth, INVIEWLib.INGridPropertyLink.inPerGrid, colSize);
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inState, INVIEWLib.INGridPropertyLink.inPerCell, INVIEWLib.INCellState.inTextDraw | INVIEWLib.INCellState.inTextRect | INVIEWLib.INCellState.inRegularView);
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaRows, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaCols, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaWidth, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.colGrid.InitProperty(INVIEWLib.INPropertyID.inDeltaHeight, INVIEWLib.INGridPropertyLink.inPerCell, 0);
			this.colGrid.Init(rowCaption, colCount);

			// Events on data grid
			this.colGrid.EventOff(INVIEWLib.INCallbackEvent.inOnAllEvents);

			// Style for data grid
			this.colGrid.StyleOn(INVIEWLib.INViewStyle.inScrollVertEnable);

			// Create data grid
			this.dataGrid = (INVIEWLib.Grid)gridLayout.CreateView(2, 2, 2, 2, INVIEWLib.INViewType.inGrid);

			this.dataGrid.InitProperty(INVIEWLib.INPropertyID.inBackColor, INVIEWLib.INGridPropertyLink.inPerCell, ARGB(Color.White));//rgb
			this.dataGrid.InitProperty(INVIEWLib.INPropertyID.inStyle, INVIEWLib.INGridPropertyLink.inPerCell, INVIEWLib.INCellStyle.inTextLeft | INVIEWLib.INCellStyle.inTextSingleline | INVIEWLib.INCellStyle.inView3dOn);
			this.dataGrid.InitProperty(INVIEWLib.INPropertyID.inWidth, INVIEWLib.INGridPropertyLink.inPerGrid, colSize);

			// Events on data grid
			this.dataGrid.EventOff(INVIEWLib.INCallbackEvent.inOnAllEvents);

			// Style for data grid
			this.dataGrid.Init(rowCount, colCount);
			//this.dataGrid.SetColWidth(1, colSize);
			//this.dataGrid.SetRowHeight(1, rowSize);
			this.dataGrid.StyleOn(INVIEWLib.INViewStyle.inScrollBothEnable);
			this.dataGrid.Bind(this.rowGrid, (int)INVIEWLib.INViewBinding.inBindVertMove);
			this.dataGrid.Bind(this.colGrid, (int)INVIEWLib.INViewBinding.inBindHorzMove);

		}

		/// <summary> 
		/// Creates an RGB from a Color object
		/// <param name="C"> Color to be converted into RGB</param>
		/// <returns>Returns uint RGB</returns>
		/// </summary>
		private uint ARGB(Color C)
		{
			uint argb = (uint)C.ToArgb();

			return ((argb & 0x00FF0000) >> 16) | (argb & 0x0000FF00) | ((argb & 0x000000FF) << 16);

		}
		#endregion

		private void toolStripButtonExecute_Click(object sender, EventArgs e)
		{
			if (queryBox.Text.Length <= 0)
				return;
		//	try
			{
				//Open a connection to a server.
				AdomdConnection con = new AdomdConnection("Datasource=localhost; Initial Catalog=Foodmart 2005;");
				con.Open();
				AdomdCommand command = con.CreateCommand();
				command.CommandText = queryBox.Text;
				//Execute a command and get a cellset back.
				CellSet cellset = command.ExecuteCellSet();
				//Display the result in the grid.
				DisplayResult(cellset);
				//Close the connection
				con.Close();
			}
			//catch (Exception ex)
			//{
			//    //Display an error message if exception occurred.
			//    MessageBox.Show(ex.Message);
			//}
		}

		//Display the result for the user
		private void DisplayResult(CellSet cellset)
		{
			//Validate the result.
			if (cellset.Axes.Count != 2)
				throw new InvalidOperationException("This sample doesn't support queries that don't return two axes");

			//Calculate the number of the columns. 
			int colCount = (0 == cellset.Axes[0].Set.Tuples.Count) ? 1 : cellset.Axes[0].Set.Tuples.Count;
			//Calculate the number of the rows. 
			int rowCount = (0 == cellset.Axes[1].Set.Tuples.Count) ? 1 : cellset.Axes[1].Set.Tuples.Count;
			//Calculate the number of the rows in the column captions.  
			int colCaption = (0 == cellset.Axes[1].Set.Hierarchies.Count) ? 1 : cellset.Axes[1].Set.Hierarchies.Count;
			//Calculate the number of the columns in the row captions.
			int rowCaption = (0 == cellset.Axes[0].Set.Hierarchies.Count) ? 1 : cellset.Axes[0].Set.Hierarchies.Count;
			InitializeGrid(colCount, rowCount, colCaption, rowCaption);
			//Show the columns captions.
			DisplayCaptions(cellset.Axes[0], true);
			//Show the rows captions.
			DisplayCaptions(cellset.Axes[1], false);
			//Show the data.
			DisplayData(cellset);
		}

		//Display the columns captions.
		private void DisplayCaptions(Axis axis, bool displayColumns)
		{
			//Iterate over all hiearchies on the column axis
			for (int iHierarchy = 0; iHierarchy < axis.Set.Hierarchies.Count; iHierarchy++)
			{
				//Iterate over all tuples on the column axis.
				//We want to merge the cells of the header if the member is duplicated along the hiearchy
				int cSkippedTuples = 1;
				for (int iTuple = 0; iTuple < axis.Set.Tuples.Count; iTuple += cSkippedTuples)
				{
					//Calculate how many cells should be merged.
					cSkippedTuples = CalculateSkippedCells(axis, iHierarchy, iTuple);
					INVIEWLib.Cell cell = null;
					if (displayColumns)
					{
						//Get the cell on the grid in the columns heading area.
						//if member was used more then onece along the hiearchy, merge the cells in the header.
						cell = this.colGrid.get_Cell(iHierarchy + 1, iTuple + 1) as INVIEWLib.Cell;
						cell.SetSize(1, cSkippedTuples);
					}
					else
					{
						//Get the cell on the grid in the rows heading area.
						//if member was used more then onece along the hiearchy, merge the cells in the header.
						cell = this.rowGrid.get_Cell(iTuple + 1, iHierarchy + 1) as INVIEWLib.Cell;
						cell.SetSize(cSkippedTuples, 1);
					}
					//Put the Member.Caption property on the grid
					Member member = axis.Set.Tuples[iTuple].Members[iHierarchy];
					cell.Text = member.Caption;
				}
			}
		}

		//Helper function that calculated the number of cells in the grid headers that should be merged.
		private int CalculateSkippedCells(Axis axis, int iHierarchy, int iTuple)
		{
			int cCells = 1;
			Member member = axis.Set.Tuples[iTuple].Members[iHierarchy];
			//Iterate over the members following a current one.
			for (int iCurrentTuple = iTuple + 1; iCurrentTuple < axis.Set.Tuples.Count; iCurrentTuple++)
			{
				//Compare Unique names of the current member and members that follows it.
				//Break when we found a member that differs from the current one.
				if (member.UniqueName != axis.Set.Tuples[iCurrentTuple].Members[iHierarchy].UniqueName)
					break;
				cCells++;
			}
			//return number of cells that can be merged.
			return cCells;
		}

		//Display the data values.
		private void DisplayData(CellSet cellset)
		{
			//iterate over the tuples in the columns and rows axes.
			for (int iCol = 0; iCol < cellset.Axes[0].Set.Tuples.Count; iCol++)
			{
				for (int iRow = 0; iRow < cellset.Axes[1].Set.Tuples.Count; iRow++)
				{
					//Get the cell on the grid in the data area.
					INVIEWLib.Cell cell = this.dataGrid.get_Cell(iRow + 1, iCol + 1) as INVIEWLib.Cell;
					//Put the Formatted value  property of the cell on the grid.
					cell.Text = cellset.Cells[iCol, iRow].FormattedValue;
				}
			}
		}

        private void queryBox_TextChanged(object sender, EventArgs e)
        {

        }

        private void AdomdGrid_OnCursorChange(object sender, AxINVIEWLib._DINViewEvents_OnCursorChangeEvent e)
        {

        }

	}
}