using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;

namespace AdomdFetchingProperties
{
	class Program
	{
		static void Main(string[] args)
		{
			FetchingNotMDDatasetProperties1();
			FetchingNotMDDatasetProperties2();
		}
		static void FetchingNotMDDatasetProperties1()
		{
			// Open a connection to the server
			AdomdConnection con = new AdomdConnection("Datasource=localhost; Initial Catalog=Foodmart 2005;");
			con.Open();

			//Execute a simple MDX statement
			AdomdCommand command = con.CreateCommand();
			command.CommandText = "SELECT Measures.Members ON COLUMNS FROM [Warehouse and Sales]";

			//Execute the command and get the CellSet object
			CellSet cellSet = command.ExecuteCellSet();

			//Iterate the axes and their hierarchies and get properties of each hierarchy 
			foreach (Axis axis in cellSet.Axes)
			{
				foreach (Hierarchy hier in axis.Set.Hierarchies)
				{
					Console.WriteLine(hier.Caption);
					Console.WriteLine(hier.Description);
				}
			}
			//Close the connection
			con.Close();
		}
		static void FetchingNotMDDatasetProperties2()
		{
			//Open a connection to the server
			AdomdConnection con = new AdomdConnection("Datasource=localhost; Initial Catalog=Foodmart 2005;");
			con.Open();

			//Execute an MDX statement
			AdomdCommand command = con.CreateCommand();
			command.CommandText = "SELECT measures.members ON COLUMNS FROM [Warehouse and Sales]";
			CellSet cellSet = command.ExecuteCellSet();

			//Iterate the axes and tuples on each axis
			foreach (Axis axis in cellSet.Axes)
			{
				foreach (Tuple tuple in axis.Set.Tuples)
				{
					Member member = tuple.Members[0];
					try
					{
						// Try to get the member.Type property; this will cause an exception
						Console.WriteLine(member.Type);
					}
					catch (InvalidOperationException ex)
					{
						Console.WriteLine(ex.Message);
						// Send a request to the server to bring all the properties of the current member
						member.FetchAllProperties();
						//Successfully print the property member.Type
						Console.WriteLine(member.Type);
					}
				}
			}
			//Close the connection
			con.Close();
		}
	}
}
