using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;

namespace AdomdIterateMetadata
{
	class Program
	{
		static void Main(string[] args)
		{
			//Connect to the server
			AdomdConnection con = new AdomdConnection();
			con.ConnectionString = "Datasource=localhost; Initial Catalog=FoodMart 2005;";
			con.Open();

			//Iterate the objects in the collection of cubes
			foreach (CubeDef cube in con.Cubes)
			{
				Console.WriteLine("Cube Name: " + cube.Name);

				//Iterate the objects in the measures collection
				foreach (Dimension dim in cube.Dimensions)
				{
					Console.WriteLine("Dimension Unique Name: " + dim.UniqueName);

					// Iterate the objects in hierarchy collection
					foreach (Hierarchy hier in dim.Hierarchies)
					{
						Console.WriteLine("Hierarchy Unique Name: " + hier.UniqueName);
						// Iterate objects in levels collection
						foreach (Level level in hier.Levels)
						{
							Console.WriteLine("Level Unique Name: " + level.UniqueName);
						}
					}
				}
			}
			//Close the connection
			con.Close();
		}
	}
}
