using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;

namespace AdomdShareSession
{
	class Program
	{
		static void Main(string[] args)
		{
			// Create the first connection object 
			AdomdConnection con = new AdomdConnection();
			con.ConnectionString = "Datasource=localhost; Initial Catalog=Foodmart 2005;";
			con.Open();

			// Create a command and send a request that will create a new calculated member on the session
			AdomdCommand command = con.CreateCommand();
            command.CommandText = "create member [Warehouse and Sales].Measures.MyCalcMember as 1";
			command.ExecuteNonQuery();

			// Check to make sure that the calculated member was created. 
            if (null != con.Cubes["Warehouse and Sales"].Measures.Find("MyCalcMember"))
                Console.WriteLine(" Measure 'MyCalcMember' is created on the session from the first connection. ");
			else
                Console.WriteLine(" Measure 'MyCalcMember' is not created on the session from the first connection. ");

			// Create the second connection object 
			AdomdConnection con2 = new AdomdConnection();
			con2.ConnectionString = "Datasource=localhost; Initial Catalog=Foodmart 2005;";

			// Set the session identifier of the first connection in the second connection object
			con2.SessionID = con.SessionID;

			// Open the second connection
			con2.Open();

			// Check to make sure that the calculated member created by first connection is available on the second connection
            if (null != con2.Cubes["Warehouse and Sales"].Measures.Find("MyCalcMember"))
                Console.WriteLine(" Measure 'MyCalcMember' is awailable on the session from the second connection. ");
			else
                Console.WriteLine(" Measure 'MyCalcMember' is not awailable on the session from the second connection. ");

			// Close the second connection
			con2.Close();

			// Close the first connection
			con.Close();
		}
	}
}
